using System;
using System.Reflection;
using UnityEditor.Experimental.GraphView;
using UnityEngine;
using UnityEngine.UIElements;

namespace ImageProcessingGraph.Editor
{
    public class IPTPort : Port
    {
        public FieldInfo fieldInfo;
        private VisualElement _exposedPropertyContainer;

        public VisualElement ExposedPropertyContainer
        {
            set
            {
                Debug.Log($"🔥 Someone is SETTING ExposedPropertyContainer to {value} 🔥");
                _exposedPropertyContainer = value;
            }
            get
            {
                return _exposedPropertyContainer;
            }
        }
        
        protected IPTPort(Orientation portOrientation, Direction portDirection, Capacity portCapacity, Type type) : base(portOrientation, portDirection, portCapacity, type)
        {

        }
        
        public static IPTPort Create(IEdgeConnectorListener connectorListener, bool isInput, Type type)
        {
            var port = new IPTPort(Orientation.Horizontal, isInput ? Direction.Input : Direction.Output,
                isInput ? Capacity.Single : Capacity.Multi, type)
            {
                m_EdgeConnector = new EdgeConnector<Edge>(connectorListener),
            };
            port.AddManipulator(port.m_EdgeConnector);
            return port;
        }
    }
}